#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2600one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 2600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2600one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one26004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


 
                         
# -------------------------------------------------------------------------------------------------
# 2600
# -------------------------------------------------------------------------------------------------                                          
shot2one26004xi = {
                  1:'0x0y2599z',
                  2:'0x1721y1948z',
                  3:'0x78y2598z',
                  4:'1008x1987y1338z',
                  5:'1019x2106y1132z',
                  6:'1027x1467y1884z',
                  7:'1032x929y2197z',
                  8:'1041x1734y1632z',
                  9:'1062x860y2211z',
                  10:'1087x790y2225z',
                  11:'1091x1396y1902z',
                  12:'1104x1920y1360z',
                  13:'1121x1664y1652z',
                  14:'1122x2040y1156z',
                  15:'112x108y2595z',
                  16:'1150x1323y1919z',
                  17:'118x2325y1155z',
                  18:'1196x1590y1672z',
                  19:'1196x1848y1382z',
                  20:'11x311y2581z',
                  21:'1204x1247y1937z',
                  22:'1221x1969y1179z',
                  23:'124x132y2593z',
                  24:'1254x1169y1954z',
                  25:'1267x1512y1692z',
                  26:'1283x1772y1404z',
                  27:'1298x1089y1971z',
                  28:'1316x1892y1202z',
                  29:'1333x1431y1712z',
                  30:'1337x1008y1988z',
                  31:'133x159y2591z',
                  32:'1365x1691y1426z',
                  33:'1372x925y2004z',
                  34:'1394x1347y1731z',
                  35:'1405x1811y1225z',
                  36:'140x186y2589z',
                  37:'1442x1607y1447z',
                  38:'1449x1261y1751z',
                  39:'145x215y2587z',
                  40:'146x274y2581z',
                  41:'147x244y2584z',
                  42:'148x317y2677z',
                  43:'1490x1726y1248z',
                  44:'1499x1173y1770z',
                  45:'149x2156y1444z',
                  46:'14x21y2599z',
                  47:'1514x1519y1469z',
                  48:'1544x1082y1789z',
                  49:'1570x1636y1271z',
                  50:'1580x1427y1490z',
                  51:'1641x1333y1512z',
                  52:'1644x1543y1293z',
                  53:'1696x1236y1533z',
                  54:'1713x1446y1316z',
                  55:'171x1963y1695z',
                  56:'175x1672y1982z',
                  57:'1775x1347y1338z',
                  58:'202x2405y966z',
                  59:'238x2304y1179z',
                  60:'25x284y2584z',
                  61:'260x1641y1999z',
                  62:'260x2131y1465z',
                  63:'271x1934y1715z',
                  64:'27x44y2599z',
                  65:'2x26y2599z',
                  66:'2x52y2599z',
                  67:'326x2381y990z',
                  68:'341x1606y2015z',
                  69:'356x2277y1202z',
                  70:'369x1900y1735z',
                  71:'369x2100y1487z',
                  72:'36x2175y1422z',
                  73:'36x256y2587z',
                  74:'38x68y2598z',
                  75:'419x1566y2032z',
                  76:'449x2351y1014z',
                  77:'45x229y2589z',
                  78:'45x93y2597z',
                  79:'464x1861y1754z',
                  80:'473x2243y1225z',
                  81:'475x2063y1508z',
                  82:'494x1523y2048z',
                  83:'50x201y2591z',
                  84:'51x119y2596z',
                  85:'53x146y2595z',
                  86:'53x173y2593z',
                  87:'555x1818y1773z',
                  88:'566x1475y2064z',
                  89:'569x2314y1038z',
                  90:'578x2021y1529z',
                  91:'586x2204y1248z',
                  92:'634x1425y2079z',
                  93:'644x1769y1792z',
                  94:'678x1973y1550z',
                  95:'686x2271y1062z',
                  96:'697x2158y1270z',
                  97:'698x1371y2095z',
                  98:'69x1986y1676z',
                  99:'728x1717y1811z',
                  100:'759x1314y2110z',
                  101:'76x2422y942z',
                  102:'774x1921y1571z',
                  103:'800x2222y1085z',
                  104:'804x2106y1293z',
                  105:'809x1660y1829z',
                  106:'815x1255y2125z',
                  107:'82x63y2597z',
                  108:'867x1193y2140z',
                  109:'867x1863y1591z',
                  110:'886x1599y1848z',
                  111:'89x1699y1965z',
                  112:'908x2050y1315z',
                  113:'911x2167y1109z',
                  114:'915x1130y2155z',
                  115:'956x1801y1612z',
                  116:'958x1064y2169z',
                  117:'959x1535y1866z',
                  118:'98x85y2596z',
                  119:'997x997y2183z'}

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2600one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2600one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2600ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE2600ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2600ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2600ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2600ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE26004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one26004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2600ONE4XI - SUCCEEDED TO PUT SHOT2ONE26004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE26004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2600ONE4XI *** FAILED TO PUT SHOT2ONE26004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2600ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one26004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one26004xi</nack2put4xi>" 
             
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2600ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one26004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
        
    except:
        print(" (STEP 3C/33) OF FIRE2600ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2600ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2600one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
